part of tecfy_core_client_package;

class LocationPropertyComponenet extends StatefulWidget {
  final String initalValue;
  final String label;
  final bool readOnly;
  final void Function(String) onChanged;
  LocationPropertyComponenet(
      {this.initalValue, this.label, this.onChanged, this.readOnly = false});
  @override
  _LocationPropertyComponenetState createState() =>
      _LocationPropertyComponenetState();
}

class _LocationPropertyComponenetState
    extends State<LocationPropertyComponenet> {
  GlobalKey<GoogleMapStateBase> _key = GlobalKey<GoogleMapStateBase>();
  String _mapStyle;
  GeoCoord point;

  @override
  initState() {
    print('------------------------------');
    print(widget.initalValue);
    if (widget.initalValue == null || widget.initalValue.isEmpty) {
      point = null;
    } else {
      var p = widget.initalValue.split(',');
      if (p.length >= 1) {
        point = GeoCoord(double.parse(p[0]), double.parse(p[1]));
      }
    }
    if (point == null) {
      // get my location
    }
    super.initState();
  }

  onChanged() {
    var r = '${point.latitude},${point.longitude}';
    widget.onChanged(r);
  }

  @override
  Widget build(BuildContext context) {
    return Container(
        child: GoogleMap(
          key: _key,
          initialZoom: 20,
          initialPosition: point ?? GeoCoord(0, 0),
          mapType: MapType.hybrid,
          mapStyle: _mapStyle,
          interactive: true,
          markers: point == null
              ? null
              : {
                  Marker(point),
                },
          onTap: widget.readOnly
              ? null
              : (coord) {
                  point = coord;
                  GoogleMap.of(_key).clearMarkers();
                  GoogleMap.of(_key).addMarker(Marker(point));
                  onChanged();
                },
          mobilePreferences: const MobileMapPreferences(
            myLocationButtonEnabled: true,
            myLocationEnabled: false,
            mapToolbarEnabled: true,
            buildingsEnabled: true,
            compassEnabled: true,
            //indoorViewEnabled: true,
            zoomGesturesEnabled: true,
            rotateGesturesEnabled: true,
            scrollGesturesEnabled: true,
            tiltGesturesEnabled: true,
//trafficEnabled: true
          ),
          webPreferences: WebMapPreferences(
            streetViewControl: true,
            fullscreenControl: true,
            mapTypeControl: true,
            panControl: true,
            overviewMapControl: true,
            rotateControl: true,
            scaleControl: true,
            zoomControl: true,
            dragGestures: true,
            scrollwheel: true,
          ),
        ),
        constraints: BoxConstraints(maxHeight: 500));
  }
}
